<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5"> <h1> Create Order </h1> </div>
        <div class="form-group row">
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-combo">
              <option> Chọn cỡ Combo (Combo size)</option>
              <option value="S"> Nhỏ</option>
              <option value="M"> Vừa</option>
              <option value="L"> Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-drink">
              <option>Chọn đồ uống</option>
            </select>
          </div>
        </div> 
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Mã voucher</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Voucher ID (mã voucher)" id="inp-voucher">
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza</label>
          <div class="col-sm-4">
            <select class = "form-control" id="select-pizza">            <!-- select chưa có id, các option chưa có value-->
              <option> Chọn loại pizza </option>
              <option value = "Seafood" > Hải sản</option>
              <option value = "Hawaii"> Ha wai </option>
              <option value = "Bacon" > Thịt hun khói </option>
            </select>
          </div>        
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Họ và tên" id="inp-hovaten"> 
          </div>
          <label for="" class="col-sm-2 col-form-label">Email</label>
          <div class="col-sm-4">
            <input type="email" class="form-control" placeholder="Email" id="inp-email"> 
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Số điện thoại</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Số điện thoại" id="inp-sdt">
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Địa chỉ" id="inp-diachi"> 
          </div>
        </div>
        <div class="form-group">
          <label>Lời nhắn</label>
          <textarea class="form-control h-75" placeholder="Lời nhắn" id="id-loinhan"></textarea>
        </div> 
        <div class="form-group">
          <button  class="btn btn-primary" onclick="onBtnCreateOderClick()" id="btn-createoder">Create Order</button>
          <button  class="btn btn-secondary"  id="btn-ShowOrderDatainNewForm">Show Order Data in New Form</button>
        </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    function onBtnCreateOderClick() {
      var vObjectRequest = {
            kichCo: "",
            duongKinh: "",
            suon: "",
            salad: "",
            loaiPizza: "",
            idVourcher: "",
            idLoaiNuocUong: "",
            soLuongNuoc: "",
            hoTen: "",
            thanhTien: 0,
            email: "",
            soDienThoai: "",
            diaChi: "",
            loiNhan: ""
        };
        ThuThapThongTin(vObjectRequest);
        if (validateThongTin(vObjectRequest) === 1) {
          var vXmlHttpCreateOrder = new XMLHttpRequest();
          callAPICreateOder(vObjectRequest,vXmlHttpCreateOrder);
          xuLiHienThi(vXmlHttpCreateOrder);
        }
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText); // ghi response text ra console.log
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }
    function ThuThapThongTin(paramObj) {
      var vSeclectCombo = document.getElementById("select-combo");
      var vVoucher = document.getElementById("inp-voucher");
      var vHoVaTen = document.getElementById("inp-hovaten");
      var vPhone = document.getElementById("inp-sdt");
      var vLoiNhan = document.getElementById("id-loinhan");
      var vSelectDrink = document.getElementById("select-drink");
      var vSelectPizza = document.getElementById("select-pizza");
      var vEmail = document.getElementById("inp-email");
      var vDiaChi = document.getElementById("inp-diachi");
      getPizza(vSeclectCombo,paramObj);
      paramObj.loaiPizza = vSelectPizza.value;
      paramObj.hoTen = vHoVaTen.value.trim();
      paramObj.idVourcher = vVoucher.value.trim();
      paramObj.idLoaiNuocUong = vSelectDrink.value;
      paramObj.email = vEmail.value.trim();
      paramObj.diaChi = vDiaChi.value.trim();
      paramObj.soDienThoai = vPhone.value.trim();
      paramObj.loiNhan = vLoiNhan.value.trim();
      var vPhanTramGiamGia = CheckVoucherIdClick(vVoucher);
      paramObj.thanhTien = paramObj.thanhTien - paramObj.thanhTien*vPhanTramGiamGia/100;
      console.log(paramObj);
    }
    function validateThongTin(paramObj) {
      if (paramObj.kichCo === "") {
        alert ("Bạn chưa chọn loại combo");
      }else if (paramObj.idLoaiNuocUong === "") {
        alert ("Bạn chưa chọn loại nước uống")
      }else if(paramObj.loaiPizza === "") {
        alert("Bạn chưa chọn loại pizza") 
      }else if (paramObj.hoTen === "") {
        alert ("bạn chưa điền họ và tên") 
      }else if (paramObj.idVourcher === "") {
        alert("bạn chưa nhập id voucher")
      }else if(paramObj.email === ""){
        alert("Bạn chưa điền email") 
      }else if(paramObj.soDienThoai === "") {
        alert("bạn chưa điền số điện thoại")
      }else if (paramObj.diaChi === "") {
        alert("bạn chưa điền địa chỉ");
      }else if(paramObj.loiNhan === ""){
        alert("bạn chưa nhập lời nhắn")
      } else return 1;
       
    }
    function getPizza(parampizza,paramObj){
      if (parampizza.value === "S") {
        paramObj.kichCo = "S (small)";
        paramObj.duongKinh = "20" ;
        paramObj.suon = "2";
        paramObj.salad = "200";
        paramObj.soLuongNuoc = "2";
        paramObj.thanhTien = 150000;
      }else       if (parampizza.value === "M") {
        paramObj.kichCo = "M (medium)";
        paramObj.duongKinh = "25 " ;
        paramObj.suon = "4";
        paramObj.salad = "300 ";
        paramObj.soLuongNuoc = "3";
        paramObj.thanhTien = 200000;
      }else       if (parampizza.value === "L") {
        paramObj.kichCo = "L (large)";
        paramObj.duongKinh = "30" ;
        paramObj.suon = "8";
        paramObj.salad = "500";
        paramObj.soLuongNuoc = "4";
        paramObj.thanhTien = 250000;
      }
    }
    function CheckVoucherIdClick(paramVoucher) {
        "use strict";
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail";
        var vVoucherId = paramVoucher.value;  //một số mã đúng để test: 95531, 81432,...lưu ý test cả mã sai
        // nếu mã giảm giấ đã nhập, tạo xmlHttp  request và gửi về server
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vBASE_URL + "/" + vVoucherId, false);
        vXmlHttp.send(null);
        var vStatusCode = vXmlHttp.status;
        if (vStatusCode == gREQUEST_STATUS_OK) { // restFullAPI successful
            // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
            console.log(vXmlHttp.responseText);
            var vRespone = JSON.parse(vXmlHttp.responseText);
            return vRespone.phanTramGiamGia;
        }
        else {
            // không nhận lại được data do vấn đề gì đó: khả năng mã voucher không dúng
            console.log("Không tìm thấy voucher " + vVoucherId);
            return 0;
        }
    }
    function callAPICreateOder(paramObj,paramXhttp) {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        paramXhttp.open("POST", vBASE_URL, true);
        paramXhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXhttp.send(JSON.stringify(paramObj));
    }
    function xuLiHienThi(paramXhttp) {
      paramXhttp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
                    var vCreatedOrder = paramXhttp.responseText;
                    console.log(vCreatedOrder);
                    var vRespone = JSON.parse(vCreatedOrder)
                    var vButton = document.getElementById("btn-ShowOrderDatainNewForm");
                    vButton.getAttribute("data-ordercode");
                    vButton.dataset.ordercode = vRespone.orderCode
                    vButton.addEventListener("click", function() {
                      onBtnShowOrderDatainNewFormClick(this)
                    });
                }
            }
    }
    function onBtnShowOrderDatainNewFormClick(paramDetailButton) {
                        console.log("Oder Code: " + paramDetailButton.dataset.ordercode);
                        var vOderCode = paramDetailButton.dataset.ordercode;
                        const vDETAIL_FORM_URL = "oderdetai.html";
                        var vUrlSiteToOpen = vDETAIL_FORM_URL +
      "?odercode=" + vOderCode ;
      window.location.href = vUrlSiteToOpen;
    }
  </script>


</body>

</html>